Subject: Re: Proposal: tell git a file has been renamed

From: Junio C Hamano <[email-masked]>
Date: Wed, 26 Apr 2023 13:39:48 -0700

Jacob Keller <[email-masked]> writes:

> The alternative would be something like Junio suggested where we have a
> separate rename storage database which is computed ahead of time (kind
> of like commit graph storage) and which could be overridden manually.
> This doesn't "bake" anything into the objects, but obviously requires
> manually keeping up to date and adds some difficulty in sharing such
> updates across remotes.

I think originally the recorded rename mechanism was dreamed up to
be a cache.  Unlike commit-graph that requires precomputation, it
would be populated incrementally when you run "git log -M" in a part
of the history that you haven't done so.  Sharing it would just be
as hard as sharing notes, once we point the rename cache with a ref,
I would think.

I cannot take credit for the idea, though.